<?php

namespace CameraBundle\Types;

use Doctrine\DBAL\Types\Type;
use Doctrine\DBAL\Platforms\AbstractPlatform;

use CameraBundle\ValueObject\Money;

class MoneyType extends Type {

	public function getSQLDeclaration(array $fieldDeclaration, AbstractPlatform $platform): string
	{
		return 'MONEY';
	}

	public function convertToPHPValue($value, AbstractPlatform $platform)
	{
		return new Money($value);
	}

	public function getName(): string
	{
		return 'money';
	}
}
